=== debian/changelog ===
lammps (0~20180822.gitb47e49223+dfsg1-2) unstable; urgency=medium

  * [803c676] Disable REAX because it causes segfault on mips*
  * [88f9fca] Update Standards-Version to 4.2.1

 -- Anton Gladky <gladk@debian.org>  Thu, 13 Sep 2018 20:52:16 +0200

lammps (0~20180822.gitb47e49223+dfsg1-1) unstable; urgency=medium

  [ Anton Gladky ]
  * [ceb6296] Update patches
  * [ffd7251] Add lammps-data binary
  * [31838f8] Switch to cmake build system
  * [50340be] Update d/copyright
  * [86e8141] New upstream version 0~20180822.gitb47e49223+dfsg1
  * [d3bd62d] Update address of FSF
  * [9a1d41f] Update autopkgtests
  * [24aefb7] Add NEWS-file

  [ Andrius Merkys ]
  * [d4bfbf3] Link against libsymspg-dev. (Closes: #901060)

 -- Anton Gladky <gladk@debian.org>  Wed, 05 Sep 2018 23:13:17 +0200
